Unit h_contr;
Interface
Uses Delphin, CONTROLS,Classes,graphics,menus;
Implementation
type
  TConvertObj = class(TWinControl)
  published
    property Align;
    property Caption;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

{--------------------}
function myTCONTROLBRINGTOFRONT(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).BRINGTOFRONT;
End;
{--------------------}
(*function myTCONTROLCLIENTTOSCREEN(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TCONTROL(slf).CLIENTTOSCREEN(S[0]);
End;
{--------------------}
function myTCONTROLDRAGGING(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TCONTROL(slf).DRAGGING;
End;
{--------------------}
function myTCONTROLDRAGDROP(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).DRAGDROP(S[0],S[1],S[2]);
End;
{--------------------}
function myTCONTROLENDDRAG(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).ENDDRAG(S[0]);
End;
{--------------------}
function myTCONTROLGETTEXTBUF(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TCONTROL(slf).GETTEXTBUF(S[0],S[1]);
End;
{--------------------}
function myTCONTROLGETTEXTLEN(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TCONTROL(slf).GETTEXTLEN;
End;
*){--------------------}
function myTCONTROLHIDE(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).HIDE;
End;
{--------------------}
function myTCONTROLINVALIDATE(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).INVALIDATE;
End;
{--------------------}
function myTCONTROLPERFORM(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TCONTROL(slf).PERFORM(S[0],S[1],S[2]);
End;
{--------------------}
function myTCONTROLREFRESH(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).REFRESH;
End;
{--------------------}
function myTCONTROLREPAINT(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).REPAINT;
End;
{--------------------}
(*function myTCONTROLSCREENTOCLIENT(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TCONTROL(slf).SCREENTOCLIENT(S[0]);
End;
*){--------------------}
function myTCONTROLSENDTOBACK(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).SENDTOBACK;
End;
{--------------------}
function myTCONTROLSETBOUNDS(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).SETBOUNDS(S[0],S[1],S[2],S[3]);
End;
{--------------------}
(*function myTCONTROLSETTEXTBUF(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).SETTEXTBUF(S[0]);
End;
*){--------------------}
function myTCONTROLSHOW(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).SHOW;
End;
{--------------------}
function myTCONTROLUPDATE(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TCONTROL(slf).UPDATE;
End;
{--------------------}
Function TCONTROLget_ALIGN(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).ALIGN;
End;

Function TCONTROLset_ALIGN(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).ALIGN:=S[0];
End;
{--------------------}
(*Function TCONTROLget_BOUNDSRECT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).BOUNDSRECT;
End;

Function TCONTROLset_BOUNDSRECT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).BOUNDSRECT:=S[0];
End;
*){--------------------}
Function TCONTROLget_CLIENTHEIGHT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).CLIENTHEIGHT;
End;

Function TCONTROLset_CLIENTHEIGHT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).CLIENTHEIGHT:=S[0];
End;
{--------------------}
(*Function TCONTROLget_CLIENTORIGIN(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).CLIENTORIGIN;
End;

Function TCONTROLset_CLIENTORIGIN(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).CLIENTORIGIN:=S[0];
End;
{--------------------}
Function TCONTROLget_CLIENTRECT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).CLIENTRECT;
End;

Function TCONTROLset_CLIENTRECT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).CLIENTRECT:=S[0];
End;
*){--------------------}
Function TCONTROLget_CLIENTWIDTH(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).CLIENTWIDTH;
End;

Function TCONTROLset_CLIENTWIDTH(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).CLIENTWIDTH:=S[0];
End;
{--------------------}
Function TCONTROLget_PARENT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := ObjToVar(TCONTROL(slf).PARENT);
End;

Function TCONTROLset_PARENT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).PARENT:=TWinControl(VarToObj(S[0]));
End;
{--------------------}
Function TCONTROLget_SHOWHINT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).SHOWHINT;
End;

Function TCONTROLset_SHOWHINT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).SHOWHINT:=S[0];
End;
{--------------------}
Function TCONTROLget_VISIBLE(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).VISIBLE;
End;

Function TCONTROLset_VISIBLE(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).VISIBLE:=S[0];
End;
{--------------------}
Function TCONTROLget_ENABLED(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).ENABLED;
End;

Function TCONTROLset_ENABLED(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).ENABLED:=S[0];
End;
{--------------------}
Function TCONTROLget_LEFT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).LEFT;
End;

Function TCONTROLset_LEFT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).LEFT:=S[0];
End;
{--------------------}
Function TCONTROLget_TOP(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).TOP;
End;

Function TCONTROLset_TOP(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).TOP:=S[0];
End;
{--------------------}
Function TCONTROLget_WIDTH(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).WIDTH;
End;

Function TCONTROLset_WIDTH(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).WIDTH:=S[0];
End;
{--------------------}
Function TCONTROLget_HEIGHT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).HEIGHT;
End;

Function TCONTROLset_HEIGHT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).HEIGHT:=S[0];
End;
{--------------------}
Function TCONTROLget_CURSOR(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).CURSOR;
End;

Function TCONTROLset_CURSOR(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).CURSOR:=S[0];
End;
{--------------------}
Function TCONTROLget_HINT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TCONTROL(slf).HINT;
End;

Function TCONTROLset_HINT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TCONTROL(slf).HINT:=S[0];
End;
{--------------------}
function myTWINCONTROLCREATE(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
Result:=ObjToVar(TWINCONTROL(slf).CREATE(TComponent(VarTOObj(S[0]))));
End;
{--------------------}
function myTWINCONTROLBROADCAST(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TWINCONTROL(slf).BROADCAST(S[0]);
End;
{--------------------}
function myTWINCONTROLCANFOCUS(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TWINCONTROL(slf).CANFOCUS;
End;
{--------------------}
function myTWINCONTROLCONTAINSCONTROL(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TWINCONTROL(slf).CONTAINSCONTROL(TControl(VarToObj(S[0])));
End;
{--------------------}
function myTWINCONTROLFOCUSED(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 Result := TWINCONTROL(slf).FOCUSED;
End;
function myTWINCONTROLINSERTCONTROL(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TWINCONTROL(slf).INSERTCONTROL(TControl(VarToObj(S[0])));
End;
function myTWINCONTROLREMOVECONTROL(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TWINCONTROL(slf).REMOVECONTROL(TControl(VarToObj(S[0])));
End;
{--------------------}
function myTWINCONTROLREALIGN(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TWINCONTROL(slf).REALIGN;
End;
{--------------------}
function myTWINCONTROLREPAINT(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TWINCONTROL(slf).REPAINT;
End;
{--------------------}
function myTWINCONTROLSCALEBY(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TWINCONTROL(slf).SCALEBY(S[0],S[1]);
End;
{--------------------}
function myTWINCONTROLSCROLLBY(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TWINCONTROL(slf).SCROLLBY(S[0],S[1]);
End;
{--------------------}
function myTWINCONTROLSETFOCUS(slf:TObject;var APropName:String;var s:array of variant):variant;
begin
 TWINCONTROL(slf).SETFOCUS;
End;
{--------------------}
(*Function TWINCONTROLget_BRUSH(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TWINCONTROL(slf).BRUSH;
End;

Function TWINCONTROLset_BRUSH(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TWINCONTROL(slf).BRUSH:=S[0];
End;
*){--------------------}
Function TWINCONTROLget_CONTROLCOUNT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TWINCONTROL(slf).CONTROLCOUNT;
End;

Function TWINCONTROLget_SHOWING(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TWINCONTROL(slf).SHOWING;
End;
{--------------------}
Function TWINCONTROLget_TABSTOP(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TWINCONTROL(slf).TABSTOP;
End;

Function TWINCONTROLset_TABSTOP(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TWINCONTROL(slf).TABSTOP:=S[0];
End;
{--------------------}
Function TWINCONTROLget_HELPCONTEXT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TWINCONTROL(slf).HELPCONTEXT;
End;

Function TWINCONTROLset_HELPCONTEXT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TWINCONTROL(slf).HELPCONTEXT:=S[0];
End;

Function TConvertObjget_ALIGN(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).ALIGN;
End;

Function TConvertObjset_ALIGN(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).ALIGN:=S[0];
End;

{--------------------}

type
TMControl=class(TControl)
end;

Function TConvertObjget_CAPTION(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TMControl(slf).CAPTION;
End;

Function TConvertObjset_CAPTION(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  TMControl(slf).CAPTION:=S[0];
End;

{--------------------}
Function TConvertObjget_COLOR(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).COLOR;
End;

Function TConvertObjset_COLOR(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).COLOR:=S[0];
End;
{--------------------}
Function TConvertObjget_CTL3D(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).CTL3D;
End;

Function TConvertObjset_CTL3D(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).CTL3D:=S[0];
End;
{--------------------}
Function TConvertObjget_DRAGCURSOR(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).DRAGCURSOR;
End;

Function TConvertObjset_DRAGCURSOR(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).DRAGCURSOR:=S[0];
End;
{--------------------}
Function TConvertObjget_DRAGMODE(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).DRAGMODE;
End;

Function TConvertObjset_DRAGMODE(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).DRAGMODE:=S[0];
End;
{--------------------}
Function TConvertObjget_ENABLED(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).ENABLED;
End;

Function TConvertObjset_ENABLED(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).ENABLED:=S[0];
End;
{--------------------}
Function TConvertObjget_FONT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := ObjToVar(TConvertObj(slf).FONT);
End;

Function TConvertObjset_FONT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).FONT:=TFont(VarToObj(S[0]));
End;
{--------------------}
Function TConvertObjget_PARENTCOLOR(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).PARENTCOLOR;
End;

Function TConvertObjset_PARENTCOLOR(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).PARENTCOLOR:=S[0];
End;
{--------------------}
Function TConvertObjget_PARENTCTL3D(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).PARENTCTL3D;
End;

Function TConvertObjset_PARENTCTL3D(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).PARENTCTL3D:=S[0];
End;
{--------------------}
Function TConvertObjget_PARENTFONT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).PARENTFONT;
End;

Function TConvertObjset_PARENTFONT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).PARENTFONT:=S[0];
End;
{--------------------}
Function TConvertObjget_PARENTSHOWHINT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).PARENTSHOWHINT;
End;

Function TConvertObjset_PARENTSHOWHINT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).PARENTSHOWHINT:=S[0];
End;
{--------------------}
Function TConvertObjget_POPUPMENU(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := ObjTOVar(TConvertObj(slf).POPUPMENU);
End;

Function TConvertObjset_POPUPMENU(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).POPUPMENU:=TPopupMenu(VarToObj(S[0]));
End;
{--------------------}
Function TConvertObjget_SHOWHINT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).SHOWHINT;
End;

Function TConvertObjset_SHOWHINT(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).SHOWHINT:=S[0];
End;
{--------------------}
Function TConvertObjget_TABORDER(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).TABORDER;
End;

Function TConvertObjset_TABORDER(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).TABORDER:=S[0];
End;
{--------------------}
Function TConvertObjget_TABSTOP(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).TABSTOP;
End;

Function TConvertObjset_TABSTOP(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).TABSTOP:=S[0];
End;
{--------------------}
Function TConvertObjget_VISIBLE(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
  Result := TConvertObj(slf).VISIBLE;
End;

Function TConvertObjset_VISIBLE(slf:TObject;var APropName:String;var s:array of variant):variant;
Begin
TConvertObj(slf).VISIBLE:=S[0];
End;


Procedure ControlsHalInit;
begin

{   AddObjectType('TCONTROL','TCOMPONENT');
   AddObjectType('TWINCONTROL','TCONTROL');
   AddObjectType('TCUSTOMCONTROL','TWINCONTROL');}

   AddProc('TCONTROL.BRINGTOFRONT',myTCONTROLBRINGTOFRONT,[2]);
   AddProc('TCONTROL.HIDE',myTCONTROLHIDE,[2]);
   AddProc('TCONTROL.INVALIDATE',myTCONTROLINVALIDATE,[2]);
   AddFun ('TCONTROL.PERFORM',myTCONTROLPERFORM,[0,0,0]);
   AddProc('TCONTROL.REFRESH',myTCONTROLREFRESH,[2]);
   AddProc('TCONTROL.REPAINT',myTCONTROLREPAINT,[2]);
   AddProc('TCONTROL.SENDTOBACK',myTCONTROLSENDTOBACK,[2]);
   AddProc('TCONTROL.SETBOUNDS',myTCONTROLSETBOUNDS,[0,0,0,0]);
   AddProc('TCONTROL.SHOW',myTCONTROLSHOW,[2]);
   AddProc('TCONTROL.UPDATE',myTCONTROLUPDATE,[2]);
   AddProp('TCONTROL.ALIGN',TCONTROLget_ALIGN,TCONTROLset_ALIGN);
   AddProp('TCONTROL.CLIENTHEIGHT',TCONTROLget_CLIENTHEIGHT,TCONTROLset_CLIENTHEIGHT);
   AddProp('TCONTROL.CLIENTWIDTH',TCONTROLget_CLIENTWIDTH,TCONTROLset_CLIENTWIDTH);
   AddProp('TCONTROL.PARENT',TCONTROLget_PARENT,TCONTROLset_PARENT);
   AddProp('TCONTROL.SHOWHINT',TCONTROLget_SHOWHINT,TCONTROLset_SHOWHINT);
   AddProp('TCONTROL.VISIBLE',TCONTROLget_VISIBLE,TCONTROLset_VISIBLE);
   AddProp('TCONTROL.ENABLED',TCONTROLget_ENABLED,TCONTROLset_ENABLED);
   AddProp('TCONTROL.LEFT',TCONTROLget_LEFT,TCONTROLset_LEFT);
   AddProp('TCONTROL.TOP',TCONTROLget_TOP,TCONTROLset_TOP);
   AddProp('TCONTROL.WIDTH',TCONTROLget_WIDTH,TCONTROLset_WIDTH);
   AddProp('TCONTROL.HEIGHT',TCONTROLget_HEIGHT,TCONTROLset_HEIGHT);
   AddProp('TCONTROL.CURSOR',TCONTROLget_CURSOR,TCONTROLset_CURSOR);
   AddProp('TCONTROL.HINT',TCONTROLget_HINT,TCONTROLset_HINT);
   AddFun ('TWINCONTROL.CANFOCUS',myTWINCONTROLCANFOCUS,[2]);
   AddFun ('TWINCONTROL.CONTAINSCONTROL',myTWINCONTROLCONTAINSCONTROL,[0]);
   AddFun ('TWINCONTROL.FOCUSED',myTWINCONTROLFOCUSED,[2]);
   AddProc('TWINCONTROL.INSERTCONTROL',myTWINCONTROLINSERTCONTROL,[0]);
   AddProc('TWINCONTROL.REMOVECONTROL',myTWINCONTROLREMOVECONTROL,[0]);
   AddProc('TWINCONTROL.SCALEBY',myTWINCONTROLSCALEBY,[0,0]);
   AddProc('TWINCONTROL.SCROLLBY',myTWINCONTROLSCROLLBY,[0,0]);
   AddProc('TWINCONTROL.SETFOCUS',myTWINCONTROLSETFOCUS,[2]);
   AddProp('TWINCONTROL.CONTROLCOUNT',TWINCONTROLget_CONTROLCOUNT,nil);
   AddProp('TWINCONTROL.SHOWING',TWINCONTROLget_SHOWING,nil);
   AddProp('TWINCONTROL.HELPCONTEXT',TWINCONTROLget_HELPCONTEXT,TWINCONTROLset_HELPCONTEXT);
   AddProp('TWINControl.ALIGN',TConvertObjget_ALIGN,TConvertObjset_ALIGN);
   AddProp('TControl.CAPTION',TConvertObjget_CAPTION,TConvertObjset_CAPTION);
   AddProp('TWINControl.TEXT',TConvertObjget_CAPTION,TConvertObjset_CAPTION);
   AddProp('TWINControl.COLOR',TConvertObjget_COLOR,TConvertObjset_COLOR);
   AddProp('TWINControl.CTL3D',TConvertObjget_CTL3D,TConvertObjset_CTL3D);
   AddProp('TWINControl.DRAGCURSOR',TConvertObjget_DRAGCURSOR,TConvertObjset_DRAGCURSOR);
   AddProp('TWINControl.DRAGMODE',TConvertObjget_DRAGMODE,TConvertObjset_DRAGMODE);
   AddProp('TWINControl.ENABLED',TConvertObjget_ENABLED,TConvertObjset_ENABLED);
   AddProp('TWINControl.FONT',TConvertObjget_FONT,TConvertObjset_FONT);
   AddProp('TWINControl.PARENTCOLOR',TConvertObjget_PARENTCOLOR,TConvertObjset_PARENTCOLOR);
   AddProp('TWINControl.PARENTCTL3D',TConvertObjget_PARENTCTL3D,TConvertObjset_PARENTCTL3D);
   AddProp('TWINControl.PARENTFONT',TConvertObjget_PARENTFONT,TConvertObjset_PARENTFONT);
   AddProp('TWINControl.PARENTSHOWHINT',TConvertObjget_PARENTSHOWHINT,TConvertObjset_PARENTSHOWHINT);
   AddProp('TWINControl.POPUPMENU',TConvertObjget_POPUPMENU,TConvertObjset_POPUPMENU);
   AddProp('TWINControl.SHOWHINT',TConvertObjget_SHOWHINT,TConvertObjset_SHOWHINT);
   AddProp('TWINControl.TABORDER',TConvertObjget_TABORDER,TConvertObjset_TABORDER);
   AddProp('TWINControl.TABSTOP',TConvertObjget_TABSTOP,TConvertObjset_TABSTOP);
   AddProp('TWINControl.VISIBLE',TConvertObjget_VISIBLE,TConvertObjset_VISIBLE);

   AddConst('clNavy',clNavy);
   AddConst('crDefault',crDefault);
   AddConst('crArrow',crArrow);
   AddConst('crCross',crCross);
   AddConst('crSize',crSize);
   AddConst('crIBeam',crIBeam);
   AddConst('crHourglass',crHourglass);
   AddConst('crDrag',crDrag);
   AddConst('alNone',alNone);
   AddConst('alTop',alTop);
   Addconst('alBottom',alBottom);
   AddConst('alLeft',alLeft);
   AddConst('alRight',alRight);
   AddConst('alClient',alClient);
   AddConst('dmAutomatic',dmAutomatic);
   AddConst('dmManual',dmManual);

end;

Initialization
    ControlsHalInit;
End.
